/*
Copyright (c) 2014 by Şükrü Çınar.

All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:

1. Redistributions of source code must retain the above copyright notice,
   this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

This program contains some code from the BSD kernel, which is copyrighted
by the Regents of the University of California. Their copyright statement
and software license is as follows:

 Copyright (c) 1986, 1988, 1991, 1993
	The Regents of the University of California.  All rights reserved.
 (c) UNIX System Laboratories, Inc.  All or some portions of this file
 are derived from material licensed to the University of California
 by American Telephone and Telegraph Co. or Unix System Laboratories,
 Inc. and are reproduced herein with the permission of UNIX System
 Laboratories, Inc.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met: 
 1. Redistributions of source code must retain the above copyright notice,
    this list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright
    notice, this list of conditions and the following disclaimer in the
    documentation and/or other materials provided with the distribution.
 4. Neither the name of the University nor the names of its contributors
    may be used to endorse or promote products derived from this software
    without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS''
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS
 BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT
 OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

#define gui_set_text(X,Y) \
 do {typeof(X)* Z= &(X); Z->cls->set_text(Z,Y);} while(0)
#define gui_get_text(X) \
 ({typeof(X)* _Z= &(X); char *_K= _Z->cls->get_text(_Z); _K;})
#define gui_set_value(X,Y) \
 do {typeof(X)* Z= &(X); Z->cls->set_value(Z,Y);} while(0)

#define gui_list_append(X, ...) \
 do { typeof(X)* Z= &(X); Z->cls->append_item(Z, __VA_ARGS__ ); } while(0)

#define gui_list_get_selected(X,Y) \
 ({ typeof(X)* Z= &(X); int _K= Z->cls->get_selected(Z,Y); _K; })

#define gui_print(X, ...) \
 do { typeof(X)* Z= &(X); Z->cls->print(Z, __VA_ARGS__ ); } while(0)

#define gui_clear(X) \
 do { typeof(X)* Z= &(X); Z->cls->clear(Z); } while(0)

 


 
typedef struct gui_label gui_label_t;

typedef struct {
  void (*set_text)(struct gui_label *,char *);
} gui_label_class_t;

struct gui_label {
  gui_label_class_t *cls;
  void *widget;
};



typedef struct gui_intlist gui_intlist_t;

typedef struct {
   int (*get_selected)(gui_intlist_t *, int *);
   int (*select_item)(gui_intlist_t *, int, int);
   void (*clear_selection)(gui_intlist_t *);
   void (*append_item)(gui_intlist_t *, const char *,int);
   void (*prepend_item)(gui_intlist_t *, const char *,int);
   void (*insert_item)(gui_intlist_t *, int, const char *,int);
   void (*remove)(gui_intlist_t *, int);
   void (*clear)(gui_intlist_t *);
} gui_intlist_class_t;


struct gui_intlist {
  gui_intlist_class_t *cls;
  void *widget;
};


typedef struct gui_button gui_button_t;

typedef struct {
  void (*set_text)(struct gui_button *,const char *);
} gui_button_class_t;

struct gui_button {
  gui_button_class_t *cls;
  void *widget;
};


typedef struct gui_text_entry gui_text_entry_t;

typedef struct {
  void (*set_text)(struct gui_text_entry *,char *);
  char* (*get_text)(struct gui_text_entry *);
} gui_text_entry_class_t;

struct gui_text_entry {
  gui_text_entry_class_t *cls;
  void *widget;
};

 

  typedef struct gui_check_box gui_check_box_t;
  typedef struct {
     void (*get_value)(gui_check_box_t *,int *);
     void (*set_value)(gui_check_box_t *,int);
  } gui_check_box_class_t;
  struct gui_check_box {
    gui_check_box_class_t *cls;
    void *widget;
  };



 typedef struct gui_message_console gui_message_console_t;

 typedef struct {
    void (*print)(gui_message_console_t *,const char *,...);
    void (*clear)(gui_message_console_t *);
    void (*append)(gui_message_console_t *, const char *, size_t);
 } gui_message_console_class_t;

 struct gui_message_console {
    gui_message_console_class_t *cls;
    void *widget;
 };



#ifdef __cplusplus
extern "C" {
#endif

void gui_init(int *argc,char **argv);
void gui_run();
void gui_flush();

#ifdef __cplusplus
}
#endif
 

typedef struct {
  void *self;
   


  gui_intlist_t ud_unmounted;

 


  gui_intlist_t ud_mounted;

 

 

 

 

 

 gui_text_entry_t file_browser;

 

 

 gui_text_entry_t mount_prg;

 


  gui_check_box_t opexec;


  gui_check_box_t opnoatime;

 

 



 gui_message_console_t message;

 



 gui_message_console_t about;

 

 


} gui_ud_main_t;

#ifdef __cplusplus
extern "C" {
#endif

gui_ud_main_t *gui_c_ud_main();

#ifdef __cplusplus
}
#endif



typedef struct gui_devopt gui_devopt_t;

typedef struct {
   int (*execute)(gui_devopt_t *);
   void (*close)(gui_devopt_t *);
} YQRZ_195;

struct gui_devopt {
  YQRZ_195 *cls;
  void *self;
   

 

 gui_label_t vendor;

 

 gui_label_t model;

 

 gui_label_t serial;

 

 gui_text_entry_t pretty_name;

 


  gui_intlist_t parts;

 

 gui_label_t selpart;

 

 gui_text_entry_t mount_label;


  gui_check_box_t opexec;


  gui_check_box_t opnoatime;

 

 


};

#ifdef __cplusplus
extern "C" {
#endif

gui_devopt_t *gui_c_devopt(void *owner);

#ifdef __cplusplus
}
#endif





#define gui_get_value(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->get_value(_Z, __VA_ARGS__ ); } while(0)

 #define gui_execute(X) ({typeof(X)* _Z= &(X); _Z->cls->execute(_Z); })

#define gui_close(X) do { typeof(X)* _Z= &(X); _Z->cls->close(_Z); } while(0)

#define gui_get_current(X, ...) ({ typeof(X)* _Z= &(X); _Z->cls->get_current(_Z, __VA_ARGS__ ); })
#define gui_set_current_file(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->set_current_file(_Z, __VA_ARGS__ ); } while(0)

#define gui_set_current_dir(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->set_current_dir(_Z, __VA_ARGS__ ); } while(0)

#define gui_append(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->append(_Z, __VA_ARGS__ ); } while(0)

#define gui_remove(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->remove(_Z, __VA_ARGS__ ); } while(0)

#define gui_clear_selection(X) do { typeof(X)* _Z= &(X); _Z->cls->clear_selection(_Z); } while(0)

#define gui_select_item(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->select_item(_Z, __VA_ARGS__ ); } while(0)


